Select a sequence of dates in calendar in Vue Calendar component

18 Nov 201810 minutes to read

The following example demonstrates how to select the week dates of chosen date in the Calendar using values property, when isMultiSelection property is enabled. Methods of Moment.js is used in this sample for calculating the start and end of week from the selected date.

<template>
    <div id="app">
      <div class="wrap" style="height:357px; display: inline-block;">
        <ejs-calendar id='calendar' ref="CalendarInstance" :isMultiSelection="isMultiSelection"
          :change="onChange"></ejs-calendar>
      </div>
      <div id="btncontainer">
        <ejs-button id="week" class="e-btn" v-on:click="onweekChange"> Week </ejs-button>
        <ejs-button id="workweek" class="e-btn" v-on:click="onworkweekChange"> Work Week </ejs-button>
      </div>
    </div>
  </template>
  <script setup>
  
  import { CalendarComponent as EjsCalendar } from "@syncfusion/ej2-vue-calendars";
  import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";
  import moment from "moment";
  import { ref } from 'vue';
  
  const CalendarInstance = ref(null);
  const isMultiSelection = true;
  
  const onChange = (args) => {
    let startOfWeek = moment(args.value).startOf('week');
    let endOfWeek = moment(args.value).endOf('week');
    if (CalendarInstance.value.$el.classList.contains('workweek')) {
      getWeekArray(startOfWeek.day(1), endOfWeek.day(5));
    } else if (CalendarInstance.value.$el.classList.contains("week")) {
      getWeekArray(startOfWeek, endOfWeek);
    }
  };
  /*selected current week dates when click the button*/
  const onweekChange = () => {
    if (CalendarInstance.value.$el.classList.contains('workweek')) {
      CalendarInstance.value.$el.classList.remove('workweek')
    }
    CalendarInstance.value.$el.classList.add('week');
    console.log(CalendarInstance.value.$el.classList);
  };
  const onworkweekChange = () => {
    if (CalendarInstance.value.$el.classList.contains('week')) {
      CalendarInstance.value.$el.classList.remove('week')
    }
    CalendarInstance.value.$el.classList.add('workweek');
    console.log(CalendarInstance.value.$el.classList);
  };
  const getWeekArray = (startOfWeek, endOfWeek) => {
    let days = [];
    let day = startOfWeek;
    while (day <= endOfWeek) {
      days.push(day.toDate());
      day = day.clone().add(1, 'd');
    }
    CalendarInstance.value.ej2Instances.values = days;
  };
  
  </script>
  <style>
  @import "../node_modules/@syncfusion/ej2-base/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
  @import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
  
  .wrap {
    margin: 0px auto;
    max-width: 250px;
  }
  
  #app {
    max-width: 550px;
  }
  
  #btncontainer {
    float: right;
    margin-left: 30px;
    margin-top: 75px;
    margin-right: 10px;
  }
  
  button#workweek {
    margin-left: 15px;
  }
  </style>
<template>
    <div id="app">
        <div class="wrap" style="height:357px; display: inline-block;">
            <ejs-calendar id='calendar' ref="CalendarInstance" :isMultiSelection="isMultiSelection"
                :change="onChange"></ejs-calendar>
        </div>
        <div id="btncontainer">
            <ejs-button id="week" class="e-btn" v-on:click="onweekChange"> Week </ejs-button>
            <ejs-button id="workweek" class="e-btn" v-on:click="onworkweekChange"> Work Week </ejs-button>
        </div>
    </div>
</template>
<script>

import { CalendarComponent } from "@syncfusion/ej2-vue-calendars";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
import moment from "moment";

export default {
    name: "App",
    components: {
        "ejs-calendar": CalendarComponent,
        "ejs-button": ButtonComponent
    },
    data() {
        return {
            isMultiSelection: true
        }
    },
    methods: {
        onChange: function (args) {
            let startOfWeek = moment(args.value).startOf('week');
            let endOfWeek = moment(args.value).endOf('week');
            if (this.$refs.CalendarInstance.$el.classList.contains('workweek')) {
                this.getWeekArray(startOfWeek.day(1), endOfWeek.day(5));
            } else if (this.$refs.CalendarInstance.$el.classList.contains("week")) {
                this.getWeekArray(startOfWeek, endOfWeek);
            }
        },
        /*selected current week dates when click the button*/
        onweekChange: function () {
            if (this.$refs.CalendarInstance.$el.classList.contains('workweek')) {
                this.$refs.CalendarInstance.$el.classList.remove('workweek')
            }
            this.$refs.CalendarInstance.$el.classList.add('week');
        },
        onworkweekChange: function () {
            if (this.$refs.CalendarInstance.$el.classList.contains('week')) {
                this.$refs.CalendarInstance.$el.classList.remove('week')
            }
            this.$refs.CalendarInstance.$el.classList.add('workweek');
        },
        getWeekArray: function (startOfWeek, endOfWeek) {
            let days = [];
            let day = startOfWeek;
            while (day <= endOfWeek) {
                days.push(day.toDate());
                day = day.clone().add(1, 'd');
            }
            this.$refs.CalendarInstance.ej2Instances.values = days;
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrap {
    margin: 0px auto;
    max-width: 250px;
}

#app {
    max-width: 550px;
}

#btncontainer {
    float: right;
    margin-left: 30px;
    margin-top: 75px;
    margin-right: 10px;
}

button#workweek {
    margin-left: 15px;
}
</style>

Select a sequence of dates in calendar in React Calendar component

18 Nov 20189 minutes to read

The following example demonstrates how to select the week dates for a chosen date in the Calendar using the values property when isMultiSelection is enabled. Moment.js is used in this sample to calculate the start and end of the week for the selected date.

To parse, format, and manipulate date values, this sample uses Moment.js. Install it with the following command:

npm i moment

import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
// import the calendarcomponent
import { CalendarComponent } from '@syncfusion/ej2-react-calendars';
import * as moment from "moment";
import * as React from "react";
import * as ReactDOM from "react-dom";
export default class App extends React.Component {
    calendarInstance;
    constructor(props) {
        super(props);
        this.onchange = this.onchange.bind(this);
        this.onweekChange = this.onweekChange.bind(this);
        this.onworkweekChange = this.onworkweekChange.bind(this);
    }
    onchange(args) {
        const startOfWeek = moment(args.value).startOf('week');
        const endOfWeek = moment(args.value).endOf('week');
        if (this.calendarInstance.element.classList.contains('workweek')) {
            this.getWeekArray(startOfWeek.day(1), endOfWeek.day(5));
        }
        else if (this.calendarInstance.element.classList.contains("week")) {
            this.getWeekArray(startOfWeek, endOfWeek);
        }
    }
    onworkweekChange() {
        if (this.calendarInstance.element.classList.contains('week')) {
            this.calendarInstance.element.classList.remove('week');
        }
        this.calendarInstance.element.classList.add('workweek');
    }
    onweekChange() {
        if (this.calendarInstance.element.classList.contains('workweek')) {
            this.calendarInstance.element.classList.remove('workweek');
        }
        this.calendarInstance.element.classList.add('week');
    }
    getWeekArray(startOfWeek, endOfWeek) {
        const days = [];
        let day = startOfWeek;
        while (day <= endOfWeek) {
            days.push(day.toDate());
            day = day.clone().add(1, 'd');
        }
        this.calendarInstance.values = days;
    }
    render() {
        return (<div id="app">
        <div className="wrap">
         <CalendarComponent id="calendar" isMultiSelection={true} change={this.onchange} ref={(element) => { this.calendarInstance = element; }}/>
        </div>
        <div id="btncontainer" className="e-btn-group e-vertical">
            <ButtonComponent onClick={this.onweekChange} id="week" className="e-btn"> Week </ButtonComponent>
            <ButtonComponent onClick={this.onworkweekChange} id="workweek" className="e-btn"> Work Week </ButtonComponent>
    </div>
  </div>);
    }
}
ReactDOM.render(<App />, document.getElementById('element'));
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
// import the calendarcomponent
import {  Calendar, CalendarComponent, ChangedEventArgs } from '@syncfusion/ej2-react-calendars';
import * as moment from "moment";
import * as React from "react";
import * as ReactDOM from "react-dom";

export default class App extends React.Component<{}, {}> {

private calendarInstance: Calendar;

constructor(props: any) {
    super(props);
    this.onchange = this.onchange.bind(this);
    this.onweekChange = this.onweekChange.bind(this);
    this.onworkweekChange = this.onworkweekChange.bind(this);
}
public onchange(args: ChangedEventArgs){
    const startOfWeek: any = moment(args.value).startOf('week');
    const endOfWeek: any = moment(args.value).endOf('week');
    if (this.calendarInstance.element.classList.contains('workweek')) {
        this.getWeekArray(startOfWeek.day(1) , endOfWeek.day(5)) ;
    } else if (this.calendarInstance.element.classList.contains("week")) {
        this.getWeekArray(startOfWeek, endOfWeek);
    }
}

public onworkweekChange(): void {
     if (this.calendarInstance.element.classList.contains('week')) {
        this.calendarInstance.element.classList.remove('week')
    }
    this.calendarInstance.element.classList.add('workweek');
}

public onweekChange(): void{
     if (this.calendarInstance.element.classList.contains('workweek')) {
         this.calendarInstance.element.classList.remove('workweek')
    }
    this.calendarInstance.element.classList.add('week');
}

public getWeekArray(startOfWeek: any ,endOfWeek: any) {
    const days = [];
    let day = startOfWeek;
    while (day <= endOfWeek) {
        days.push(day.toDate());
        day = day.clone().add(1, 'd');
    }
   this.calendarInstance.values = days;
   }

    public render() {
        return (
    <div id="app">
        <div className="wrap">
         <CalendarComponent id="calendar" isMultiSelection={true}  change={this.onchange} ref={(element) => {(this.calendarInstance as Calendar | null) = element }} />
        </div>
        <div id="btncontainer" className="e-btn-group e-vertical">
            <ButtonComponent onClick={this.onweekChange} id="week" className="e-btn"> Week </ButtonComponent>
            <ButtonComponent onClick={this.onworkweekChange} id="workweek" className="e-btn"> Work Week </ButtonComponent>
    </div>
  </div>
  );
}
}
ReactDOM.render(<App />, document.getElementById('element'));

Select a sequence of dates in calendar in Angular Calendar component

18 Nov 20185 minutes to read

The following example demonstrates how to select the week dates of chosen date in the Calendar using values property, when isMultiSelection property is enabled. Methods of Moment.js is used in this sample for calculating the start and end of week from the selected date.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { CalendarModule } from '@syncfusion/ej2-angular-calendars'




import { Component, ViewChild } from '@angular/core';
import { CalendarComponent } from '@syncfusion/ej2-angular-calendars';
import * as moment from 'moment';

@Component({
imports: [
        
        CalendarModule //declaration of ej2-ng-calendars module into NgModule
    ],


standalone: true,
    selector: 'app-root',
    styleUrls: ['./style.css'],
    template: `
        <!-- Rendering the Calendar with Multi selection option--->
        <div class="wrapelement">
            <ejs-calendar #ejCalendar id="calendar" isMultiSelection='true' (change)="onChange($event)"></ejs-calendar>
            </div>
            <div class='btncontainer e-btn-group e-vertical'>
            <input type="radio" id="workweek" name="week" value="workweek" (click)="workWeek()" />
            <label class="e-btn" for="workweek">Work Week</label>
            <input type="radio" id="week" name="week" value="week" (click)="week()"/>
            <label class="e-btn" for="week">Week</label>
            </div>
        `
})
export class AppComponent {
    @ViewChild('ejCalendar') CalendarInstance?: CalendarComponent;
    /*selected current week dates when click the button*/
    workWeek() {
        if (this.CalendarInstance?.element.classList.contains('week')) {
            this.CalendarInstance.element.classList.remove('week')
        }
        this.CalendarInstance?.element.classList.add('workweek');
    }

    week() {
        if (this.CalendarInstance?.element.classList.contains('workweek')) {
            this.CalendarInstance.element.classList.remove('workweek')
        }
        this.CalendarInstance?.element.classList.add('week');
    }

    onChange(args: any) {
        var startOfWeek = moment(args.value).startOf('week');
        var endOfWeek: any = moment(args.value).endOf('week');
        if (this.CalendarInstance?.element.classList.contains('workweek')) {
            this.getWeekArray(startOfWeek.day(1), endOfWeek.day(5), this);
        } else if (this.CalendarInstance?.element.classList.contains("week")) {
            this.getWeekArray(startOfWeek, endOfWeek, this);
        }
    }

    getWeekArray(startOfWeek: any, endOfWeek: number, obj: this) {
        var days = [];
        var day = startOfWeek;
        while (day <= endOfWeek) {
            days.push(day.toDate());
            day = day.clone().add(1, 'd');
        }
        (obj.CalendarInstance as CalendarComponent ).values = days;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));